// -------------------------------------------------------------------------------
// 
// 		cwCu		ahvOwb_t@C
// 
// 				Ver 3.22c
// 
// -------------------------------------------------------------------------------

#ifndef DXBASEIMAGE_H
#define DXBASEIMAGE_H

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxThread.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// L[u}bv̖ʂ̐
#define CUBEMAP_SURFACE_NUM					(6)

// YUV֘A̒`
#define YUV_RV								(0)
#define YUV_GU								(1)
#define YUV_GV								(2)
#define YUV_BU								(3)
#define YUV_Y								(4)

#define BASEIM								BaseImageManage

// \̒` --------------------------------------------------------------------

// ėp摜ǂݍ݂ɕKvȃO[of[^W߂\
struct CREATEBASEIMAGETYPE2_GPARAM
{
	int						( *UserImageLoadFunc4[ MAX_USERIMAGEREAD_FUNCNUM ] )( STREAMDATA *Src, BASEIMAGE *BaseImage ) ;	// [U[摜ǂݍ݊֐Ver4
	int						UserImageLoadFuncNum4 ;																		// [U[摜ǂݍ݊֐Ver4̐
	int						GetFormatOnly ;																				// tH[}bg̎擾݂̂sǂ( TRUE:tH[}bg̎擾̂ݍs  FALSE:f[^ǂݍ )
} ;

// 摜̓ǂݍ݂ɕKvȃO[of[^Z߂\
struct LOADBASEIMAGE_GPARAM
{
	CREATEBASEIMAGETYPE2_GPARAM CreateGraphImageType2GParam ;		// CreateGraphImageType2_UseGParam Ŏgpf[^

	STREAMDATASHREDTYPE2W	StreamDataShred2 ;						// Xg[f[^ANZXp֐Q
	STREAMDATASHRED			FileStreamDataShred ;					// t@Cf[^ANZXp֐
	STREAMDATASHRED			MemStreamDataShred ;					// f[^ANZXp֐

	int						ConvertPremultipliedAlpha ;				// ǂݍݏɏZς݃At@̉摜ɕϊ邩ǂ̃tO( TRUE:ϊs  FALSE:ϊsȂ )
	int						AlphaTestImageCreateFlag ;				// At@eXggpOtBbN쐬邩ǂ̃tO( TRUE:eXggp  FALSE:eXg͎gpȂ )
	DWORD					TransColor ;							// ߐF( AlphaTestImageCreateFlag  TRUE ̏ꍇp )
} ;

// BASEIMAGE + DIB ֌W̏\
struct BASEIMAGEMANAGE
{
	int						( *UserImageLoadFunc4[ MAX_USERIMAGEREAD_FUNCNUM ] )( STREAMDATA *Src, BASEIMAGE *BaseImage ) ;																									// [U[摜ǂݍ݊֐Ver4
	int						UserImageLoadFuncNum4 ;																																										// [U[摜ǂݍ݊֐Ver4̐
/*
	int						( *UserImageLoadFunc3[ MAX_USERIMAGEREAD_FUNCNUM ] )( void *DataImage, int DataImageSize, int DataImageType, int BmpFlag, BASEIMAGE *BaseImage, BITMAPINFO **BmpInfo, void **GraphData ) ;		// [U[摜ǂݍ݊֐Ver3
	int						UserImageLoadFuncNum3 ;																																										// [U[摜ǂݍ݊֐Ver3̐

	int						( *UserImageLoadFunc2[ MAX_USERIMAGEREAD_FUNCNUM ] )( void *Image, int ImageSize, int ImageType, BITMAPINFO **BmpInfo, void **GraphData ) ;													// [U[摜ǂݍ݊֐Ver2
	int						UserImageLoadFuncNum2 ;																																										// [U[摜ǂݍ݊֐Ver2̐

	int						( *UserImageLoadFunc[ MAX_USERIMAGEREAD_FUNCNUM ] )( FILE *fp, BITMAPINFO **BmpInfo, void **GraphData ) ;																					// [U[摜ǂݍ݊֐
	int						UserImageLoadFuncNum ;																																										// [U[摜ǂݍ݊֐̐
*/

	DX_CRITICAL_SECTION		CriticalProcessHandle ;					// f[^ՓˉpNeBJZNV
	int						InitializeFlag ;						// tO

	int						Bmp32AllZeroAlphaToXRGB8 ;				// 32bit bmp 摜̂`ׂĂO`𖳎邩ǂ
	int						LowLoadFlag ;							// OtBbN̒ᑬǂݍ݂stO
	int						ImageShavedMode ;						// F̊gUp^[
	int						ConvertPremultipliedAlpha ;				// ǂݍݏɏZς݃At@̉摜ɕϊ邩ǂ̃tO( TRUE:ϊs  FALSE:ϊsȂ )

	int						AlphaTestImageCreateFlag ;				// At@eXggpOtBbN쐬邩ǂ̃tO( TRUE:eXggp  FALSE:eXg͎gpȂ )
	DWORD					TransColor ;							// ߐF( AlphaTestImageCreateFlag  TRUE ̏ꍇp )

	BYTE					RgbToPmaTable[ 256 ][ 256 ] ;			// RGBlPMAlɕϊۂɎgpe[u[ RGBl ][ Al ]
	BYTE					PmaToRgbTable[ 256 ][ 256 ] ;			// PMAlRGBlɕϊۂɎgpe[u[ RGBl ][ Al ]
} ;


// e[u-----------------------------------------------------------------------

extern BYTE YUVLimitTable[ 512 * 2 + 256 ] ;
extern int YUVTable[ 5 ][ 256 ] ;		// 0:rv  1:gu   2:gv   3:bu   4:y

// ϐ錾 --------------------------------------------------------------

// ˑ̉摜ǂݍ݊֐z
extern int ( *DefaultImageLoadFunc_PF[] )( STREAMDATA *Src, BASEIMAGE *BaseImage, int GetFormatOnly ) ;

// {C[WǗpf[^
extern BASEIMAGEMANAGE BaseImageManage ;

// ֐vg^Cv錾-----------------------------------------------------------

// An
extern	int		InitializeBaseImageManage( void ) ;															// {C[WǗ̏
extern	int		TerminateBaseImageManage( void ) ;															// {C[WǗ̌n

// 摜ǂݍ݊֐
extern	int		SetBmp32AllZeroAlphaToXRGB8( int Flag ) ;															// 32bit bmp 摜̂`ׂĂO`𖳎邩ǂ̃tOZbg

extern	int		ScalingBltBaseImage(
					int SrcX1,  int SrcY1,  int SrcX2,  int SrcY2,  BASEIMAGE *SrcBaseImage,
					int DestX1, int DestY1, int DestX2, int DestY2, BASEIMAGE *DestBaseImage, int Bilinear = TRUE ) ;		// {C[Wf[^g]
extern	int		GraphHalfScaleBlt(	const COLORDATA *ColorData,
										      void *DestGraphData, int DestPitch,
										const void *SrcGraphData,  int SrcPitch,
										int DestX, int DestY, int SrcX, int SrcY, int SrcWidth, int SrcHeight ) ;	// Q̂PXP[OȂOtBbNf[^ԓ]sÂߊ{̓]`͎włȂ
extern	int		NoneMaskFill( RECT *Rect, void *ImageData, int Pitch, COLORDATA *ColorData, unsigned int Fill = 0xff ) ;		// gĂȂrbgw̒lŖ߂


extern	int		ConvertYV12ToXRGB32( void *YV12Image, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// YV12 tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ
extern	int		ConvertNV11ToXRGB32( void *NV11Image, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// NV11 tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ
extern	int		ConvertNV12ToXRGB32( void *NV12Image, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// NV12 tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ
extern	int		ConvertYUY2ToXRGB32( void *YUY2Image, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// YUY2 tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ
extern	int		ConvertUYVYToXRGB32( void *UYVYImage, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// UYVY tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ
extern	int		ConvertYVYUToXRGB32( void *YVYUImage, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// YVYU tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ

extern	int		ConvertYV12ToYPlane_UVPlane( void *YV12Image, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// YV12 tH[}bg̃C[W YUṼC[Wɕ
extern	int		ConvertNV11ToYPlane_UVPlane( void *NV11Image, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// NV11 tH[}bg̃C[W YUṼC[Wɕ
extern	int		ConvertNV12ToYPlane_UVPlane( void *NV12Image, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// NV12 tH[}bg̃C[W YUṼC[Wɕ
extern	int		ConvertYUY2ToYPlane_UVPlane( void *YUY2Image, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// YUY2 tH[}bg̃C[W YUṼC[Wɕ
extern	int		ConvertUYVYToYPlane_UVPlane( void *UYVYImage, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// UYVY tH[}bg̃C[W YUṼC[Wɕ
extern	int		ConvertYVYUToYPlane_UVPlane( void *YVYUImage, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// YVYU tH[}bg̃C[W YUṼC[Wɕ

extern	void	InitCreateBaseImageType2GParam( CREATEBASEIMAGETYPE2_GPARAM *GParam, int GetFormatOnly ) ;				// CREATEBASEIMAGETYPE2_GPARAM ̃f[^Zbg
extern	void	InitLoadBaseImageGParam( LOADBASEIMAGE_GPARAM *GParam, int GetFormatOnly ) ;							// LOADBASEIMAGE_GPARAM ̃f[^Zbg

// CreateGraphImageType2 ̃O[oϐɃANZXȂo[W
extern	int		CreateGraphImageType2_UseGParam( CREATEBASEIMAGETYPE2_GPARAM *GParam, STREAMDATA *Src, BASEIMAGE *Dest ) ;

// CreateGraphImageOrDIBGraph ̃O[oϐɃANZXȂo[W
extern	int		CreateGraphImageOrDIBGraph_UseGParam(
					LOADBASEIMAGE_GPARAM *GParam,
					const wchar_t *FileName,
					const void *DataImage, int DataImageSize, int DataImageType,
					int BmpFlag, int ReverseFlag, int NotUseTransColor,
					BASEIMAGE *BaseImage, BITMAPINFO **BmpInfo, void **GraphData
				) ;

// CreateGraphImage_plus_Alpha ̃O[oϐɃANZXȂo[W
extern	int		CreateGraphImage_plus_Alpha_UseGParam(
					LOADBASEIMAGE_GPARAM *GParam,
					const wchar_t *FileName,
					const void *RgbImage, int RgbImageSize, int RgbImageType,
					const void *AlphaImage, int AlphaImageSize, int AlphaImageType,
					BASEIMAGE *RgbGraphImage, BASEIMAGE *AlphaGraphImage,
					int ReverseFlag, int NotUseTransColor
				) ;


// wchar_tŊ֐
extern	int		CreateGraphImageOrDIBGraph_WCHAR_T(    const wchar_t *FileName, const void *DataImage, int DataImageSize, int DataImageType /* LOADIMAGE_TYPE_FILE  */ , int BmpFlag, int ReverseFlag, int NotUseTransColor, BASEIMAGE *BaseImage, BITMAPINFO **BmpInfo, void **GraphData ) ;
extern	int		GetImageSize_File_WCHAR_T(             const wchar_t *FileName, int *SizeX, int *SizeY ) ;
extern	int		CreateGraphImage_plus_Alpha_WCHAR_T(   const wchar_t *FileName, const void *RgbBaseImage, int RgbImageSize, int RgbImageType, const void *AlphaImage, int AlphaImageSize, int AlphaImageType, BASEIMAGE *RgbGraphImage, BASEIMAGE *AlphaGraphImage, int ReverseFlag, int NotUseTransColor ) ;
#ifdef WINDOWS_DESKTOP_OS
extern	HBITMAP	CreateDIBGraph_WCHAR_T(                const wchar_t *FileName,                                                                                                                                        int ReverseFlag,          COLORDATA *SrcColor ) ;
extern	int		CreateDIBGraph_plus_Alpha_WCHAR_T(     const wchar_t *FileName, HBITMAP *RGBBmp, HBITMAP *AlphaBmp,                                                                                                    int ReverseFlag = FALSE , COLORDATA *SrcColor = NULL ) ;
extern	HBITMAP	CreateDIBGraphVer2_WCHAR_T(            const wchar_t *FileName, const void *MemImage, int MemImageSize,                                             int ImageType,                                     int ReverseFlag,          COLORDATA *SrcColor ) ;
extern	int		CreateDIBGraphVer2_plus_Alpha_WCHAR_T( const wchar_t *FileName, const void *MemImage, int MemImageSize, const void *AlphaImage, int AlphaImageSize, int ImageType, HBITMAP *RGBBmp, HBITMAP *AlphaBmp, int ReverseFlag,          COLORDATA *SrcColor ) ;
#endif // WINDOWS_DESKTOP_OS
extern	int		CreateBaseImage_WCHAR_T(               const wchar_t *FileName, const void *FileImage, int FileImageSize, int DataType /*=LOADIMAGE_TYPE_FILE*/ , BASEIMAGE *BaseImage,  int ReverseFlag ) ;
extern	int		CreateBaseImageToFile_WCHAR_T(         const wchar_t *FileName,                                                                                   BASEIMAGE *BaseImage,  int ReverseFlag = FALSE ) ;

#ifndef DX_NON_JPEGREAD
extern	int		ReadJpegExif_WCHAR_T(                  const wchar_t *FilePath, const void *FileImage, size_t FileImageSize, BYTE *ExifBuffer, size_t ExifBufferSize ) ;
#endif // DX_NON_JPEGREAD

#ifndef DX_NON_SAVEFUNCTION

extern	int		SaveBaseImageToBmp_WCHAR_T(            const wchar_t *FilePath, const BASEIMAGE *BaseImage ) ;
extern	int		SaveBaseImageToDds_WCHAR_T(            const wchar_t *FilePath, const BASEIMAGE *BaseImage, int CubeMapFlag = FALSE , int MipMapCount = 1 ) ;
#ifndef DX_NON_PNGREAD
extern	int		SaveBaseImageToPng_WCHAR_T(            const wchar_t *FilePath,       BASEIMAGE *BaseImage, int CompressionLevel ) ;
#endif // DX_NON_PNGREAD
#ifndef DX_NON_JPEGREAD
extern	int		SaveBaseImageToJpeg_WCHAR_T(           const wchar_t *FilePath,       BASEIMAGE *BaseImage, int Quality, int Sample2x1 ) ;
#endif // DX_NON_JPEGREAD

#endif // DX_NON_SAVEFUNCTION



// ˑEI֐
extern	int		InitializeBaseImageManage_PF( void ) ;													// {C[WǗ̊ˑ̏
extern	int		TerminateBaseImageManage_PF( void ) ;													// {C[WǗ̊ˑ̌n


// CC֐E}N---------------------------------------------------------

// x_Px_ɕϊ
__inline float Float16ToFloat32( WORD Float16 )
{
	unsigned int s ;
	int e ;
	unsigned int f ;
	unsigned int dest ;

	if( Float16 == 0 )
	{
		return	0.0f ;
	}

	s =     Float16 & 0x8000 ;
	e = ( ( Float16 & 0x7c00 ) >> 10 ) - 15 + 127 ;
	f =     Float16 & 0x03ff ;
	dest = ( s << 16 ) | ( ( e << 23 ) & 0x7f800000 ) | ( f << 13 ) ;
	return	*( ( float * )&dest ) ;
}

// Px_𔼐x_ɕϊ
__inline WORD Float32ToFloat16( float Float32 )
{
	unsigned int src = *( ( DWORD * )&Float32 ) ;
	int e ;
	unsigned int s ;
	unsigned int f ;

	if( src == 0 )
	{
		return 0 ;
	}

	e = ( ( src & 0x7f800000 ) >> 23 ) - 127 + 15 ;
	if( e < 0 )
	{
		return 0 ;
	}
	else
	if( e > 31 )
	{
		e = 31 ;
	}

	s = src & 0x80000000 ;
	f = src & 0x007fffff ;
	return ( ( s >> 16 ) & 0x8000 ) | ( ( e << 10 ) & 0x7c00 ) | ( ( f >> 13 ) & 0x03ff ) ;
}

// DrawPixel ̕`֐ŎgpJ[l擾
#ifndef DX_NON_GRAPHICS
	#define GetColor_Macro( /*int*/ Red, /*int*/ Green, /*int*/ Blue, /*int*/ Dest )\
	{\
		const COLORDATA *ColorData ;\
	\
		/* FԂ */\
		if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )\
		{\
			Dest = 0xff000000 | ( ( ( unsigned int )( Red ) ) << 16 ) | ( ( ( unsigned int )( Green ) ) << 8 ) | ( ( unsigned int )( Blue ) ) ;\
		}\
		else\
		{\
			ColorData = GetMemImgColorData( GSYS.Screen.MainScreenColorBitDepth == 16 ? 0 : 1, FALSE, FALSE ) ;\
			Dest = ColorData->NoneMask +\
						( ( ( BYTE )( Red   ) >> ( 8 - ColorData->RedWidth   ) ) << ColorData->RedLoc   ) +\
						( ( ( BYTE )( Green ) >> ( 8 - ColorData->GreenWidth ) ) << ColorData->GreenLoc ) +\
						( ( ( BYTE )( Blue  ) >> ( 8 - ColorData->BlueWidth  ) ) << ColorData->BlueLoc  ) ;\
		}\
	}
#else // DX_NON_GRAPHICS
	#define GetColor_Macro( /*int*/ Red, /*int*/ Green, /*int*/ Blue, /*int*/ Dest )	0
#endif // DX_NON_GRAPHICS

// J[lԁA΁AAAt@̒l擾
#ifndef DX_NON_GRAPHICS
	#define GetColor2_Macro( /* unsigned int */ Color, /* int */Red, /* int */Green, /* int */Blue )\
	{\
		/* FԂ */\
		if( GSYS.Setting.ValidHardware && GSYS.Screen.UserScreenImagePixelFormatMatchSoftRenderMode == FALSE )\
		{\
			Red   = ( int )( ( Color >> 16 ) & 0xff ) ;\
			Green = ( int )( ( Color >>  8 ) & 0xff ) ;\
			Blue  = ( int )( ( Color       ) & 0xff ) ;\
		}\
		else\
		{\
			const COLORDATA *ColorData ;\
			int MaxRed ;\
			int MaxGreen ;\
			int MaxBlue ;\
\
			ColorData = GetMemImgColorData( GSYS.Screen.MainScreenColorBitDepth == 16 ? 0 : 1, FALSE, FALSE ) ;\
\
			MaxRed		= ( 1 << ColorData->RedWidth   ) - 1 ;\
			MaxGreen	= ( 1 << ColorData->GreenWidth ) - 1 ;\
			MaxBlue		= ( 1 << ColorData->BlueWidth  ) - 1 ;\
\
			/* Fi[ */\
			Red		= ( int )( ( ( Color & ColorData->RedMask   ) >> ColorData->RedLoc   ) * 255 / MaxRed   ) ;\
			Green	= ( int )( ( ( Color & ColorData->GreenMask ) >> ColorData->GreenLoc ) * 255 / MaxGreen ) ;\
			Blue	= ( int )( ( ( Color & ColorData->BlueMask  ) >> ColorData->BlueLoc  ) * 255 / MaxBlue  ) ;\
		}\
	}
#else // DX_NON_GRAPHICS
	#define GetColor2_Macro( /* unsigned int */ Color, /* int */ Red, /* int */ Green, /* int */ Blue )
#endif // DX_NON_GRAPHICS


#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DXBASEIMAGE_H
