// -------------------------------------------------------------------------------
// 
// 		cwCu		VXevO
// 
// 				Ver 3.22c
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define DX_MAKE

// CN[h ------------------------------------------------------------------
#include "DxSystem.h"
#include "DxMemory.h"
#include "DxBaseFunc.h"
#include "DxUseCLib.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

DXSYSTEMDATA DxSysData ;

// ֐vg^Cv錾-----------------------------------------------------------

// vO --------------------------------------------------------------------

// EI֌W

// DxSysData ֌W̏s
extern int DxLib_SysInit( void )
{
	// INGXg̃tO|
	DxSysData.EndRequestFlag = FALSE ;

	// I
	return 0 ;
}

// INGXgs
extern int DxLib_EndRequest( void )
{
	DxSysData.EndRequestFlag = TRUE ;

	// I
	return 0 ;
}

// INGXg̏Ԃ擾
extern int DxLib_GetEndRequest( void )
{
	return DxSysData.EndRequestFlag ;
}







// CuĂ邩ǂ擾( ߂l: TRUE=Ă  FALSE=ĂȂ )
extern int NS_DxLib_IsInit( void )
{
	return DxSysData.DxLib_InitializeFlag ;
}






// G[֐

// ŌɔG[̃G[R[h擾( ߂l@0:G[ĂȂA̓G[R[ho͂ɑΉG[ĂȂ@@0ȊOFG[R[hADX_ERRORCODE_WIN_DESKTOP_24BIT_COLOR Ȃ )
extern int NS_GetLastErrorCode( void )
{
	return DxSysData.LastErrorCode ;
}

// ŌɔG[̃G[bZ[Ww̕obt@Ɏ擾
extern int NS_GetLastErrorMessage( TCHAR *StringBuffer, int StringBufferBytes )
{
	ConvString( ( char * )DxSysData.LastErrorMessage, -1, WCHAR_T_CHARCODEFORMAT, ( char * )StringBuffer, StringBufferBytes, _TCHARCODEFORMAT ) ;

	return 0 ;
}

// G[R[hEbZ[Wݒ肷
extern int DxLib_SetLastError( int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ */, const wchar_t *ErrorMessage )
{
	DxSysData.LastErrorCode = ErrorCode ;

	if( ErrorMessage == NULL )
	{
		DxSysData.LastErrorMessage[ 0 ] = L'\0' ;
	}
	else
	{
		CL_strcpy_s( WCHAR_T_CHARCODEFORMAT, ( char * )DxSysData.LastErrorMessage, sizeof( DxSysData.LastErrorMessage ), ( char * )ErrorMessage ) ;
	}

	return 0 ;
}

// tCũG[s
extern int DxLib_FmtError( const wchar_t *FormatString , ... )
{
	va_list VaList ;
	wchar_t String[ 1024 ];

	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	_VSWNPRINTF( String , sizeof( String ) / 2, FormatString , VaList ) ;

	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// G[ɂ܂킷
	return DxLib_Error( String ) ;
}

// tCũG[s
extern int DxLib_FmtErrorUTF16LE( const char *FormatString , ... )
{
	va_list VaList ;
	char String[ 2048 ];

	// Oo͗p̃XgZbg
	va_start( VaList , FormatString ) ;

	// ҏW̕擾
	CL_vsnprintf( DX_CHARCODEFORMAT_UTF16LE, TRUE, CHAR_CHARCODEFORMAT, WCHAR_T_CHARCODEFORMAT, String, sizeof( String ) / 2, FormatString, VaList ) ;

	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// G[ɂ܂킷
	return DxLib_ErrorUTF16LE( String ) ;
}

















// Nbv{[h֌W

// Nbv{[hɊi[ĂeLXgf[^ǂݏoA-1 ̏ꍇ̓Nbv{[hɃeLXgf[^͖Ƃ( DestBuffer  NULL nƊi[ɕKvȃf[^TCYԂĂ )
extern int NS_GetClipboardText( TCHAR *DestBuffer )
{
	return GetClipboardText_PF( DestBuffer ) ;
}

// Nbv{[hɊi[ĂeLXgf[^ǂݏoA-1 ̏ꍇ̓Nbv{[hɃeLXgf[^͖Ƃ( DestBuffer  NULL nƊi[ɕKvȃf[^TCYԂĂ )
extern int GetClipboardText_WCHAR_T( wchar_t *DestBuffer )
{
	return GetClipboardText_WCHAR_T_PF( DestBuffer ) ;
}

// Nbv{[hɃeLXgf[^i[
extern int NS_SetClipboardText( const TCHAR *Text )
{
#ifdef UNICODE
	return SetClipboardText_WCHAR_T_PF( Text ) ;
#else
	int Result ;

	TCHAR_TO_WCHAR_T_STRING_ONE_BEGIN( Text, return -1 )

	Result = SetClipboardText_WCHAR_T_PF( UseTextBuffer ) ;

	TCHAR_TO_WCHAR_T_STRING_END( Text )

	return Result ;
#endif
}

// Nbv{[hɃeLXgf[^i[
extern int SetClipboardText_WCHAR_T( const wchar_t *Text )
{
	return SetClipboardText_WCHAR_T_PF( Text ) ;
}

// Nbv{[hɃeLXgf[^i[
extern int NS_SetClipboardTextWithStrLen( const TCHAR *Text, size_t TextLength )
{
	int Result ;
#ifdef UNICODE
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( Text, TextLength, return -1 )
	Result = SetClipboardText_WCHAR_T( UseTextBuffer ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( Text )
#else
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( Text, TextLength, return -1 )
	Result = SetClipboardText_WCHAR_T( UseTextBuffer ) ;
	TCHAR_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( Text )
#endif
	return Result ;
}

// Nbv{[hɃeLXgf[^i[
extern int SetClipboardTextWithStrLen_WCHAR_T( const wchar_t *Text, size_t TextLength )
{
	int Result ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_ONE_BEGIN( Text, TextLength, return -1 )
	Result = SetClipboardText_WCHAR_T( UseTextBuffer ) ;
	WCHAR_T_STRING_WITH_STRLEN_TO_WCHAR_T_STRING_END( Text )
	return Result ;
}


























// init@C֌W

// GetPrivateProfileString ̂cwCu
struct GetPrivateProfileStringDxInfo
{
	BYTE		*FileBuffer ;
	size_t		FileSize ;
	DWORD		FileAddr ;
	DWORD		Semicolon ;
	DWORD		BracketL ;
	DWORD		BracketR ;
	DWORD		Equal ;
	DWORD		Space ;
	DWORD		Tab ;
	DWORD		CR ;
	DWORD		LF ;
	int			IniFileCharCodeFormat ;
	DWORD		UnitBytes ;
	TCHAR		*ReturnedStringBuffer ;
	size_t		ReturnedStringBufferBytes ;
	DWORD		DestBytes ;
} ;

__inline DWORD GetPrivateProfileStringDx_NextChar( GetPrivateProfileStringDxInfo &Info, int *pCharBytes, int EnableSemicolon, int LFEnd )
{
	*pCharBytes = 0 ;
	while( Info.FileAddr < Info.FileSize )
	{
		DWORD CharCode ;
		int CharBytes ;

		CharCode = GetCharCode( ( char * )( Info.FileBuffer + Info.FileAddr ), Info.IniFileCharCodeFormat, &CharBytes ) ;
		if( CharCode == Info.LF && LFEnd )
		{
			return 0 ;
		}
		else
		if( CharCode == Info.Space || CharCode == Info.Tab || CharCode == Info.CR || CharCode == Info.LF )
		{
			Info.FileAddr += CharBytes ;
		}
		else
		if( CharCode == Info.Semicolon && EnableSemicolon )
		{
			Info.FileAddr += CharBytes ;
			while( Info.FileAddr < Info.FileSize )
			{
				CharCode = GetCharCode( ( char * )( Info.FileBuffer + Info.FileAddr ), Info.IniFileCharCodeFormat, &CharBytes ) ;
				Info.FileAddr += CharBytes ;
				if( CharCode == Info.LF )
				{
					if( LFEnd )
					{
						return 0 ;
					}
					break ;
				}
			}
		}
		else
		{
			*pCharBytes = CharBytes ;
			return CharCode ;
		}
	}

	return 0 ;
}

__inline void GetPrivateProfileStringDx_NextLine( GetPrivateProfileStringDxInfo &Info )
{
	while( Info.FileAddr < Info.FileSize )
	{
		DWORD CharCode ;
		int CharBytes ;

		CharCode = GetCharCode( ( char * )( Info.FileBuffer + Info.FileAddr ), Info.IniFileCharCodeFormat, &CharBytes ) ;
		Info.FileAddr += CharBytes ;
		if( CharCode == Info.LF )
		{
			return ;
		}
	}
}

__inline DWORD GetPrivateProfileStringDx_GetName( GetPrivateProfileStringDxInfo &Info, DWORD &NameBytes, int *pCharBytes, int EqualEnd )
{
	NameBytes = 0 ;
	while( Info.FileAddr + NameBytes < Info.FileSize )
	{
		DWORD CharCode ;
		int CharBytes ;

		CharCode = GetCharCode( ( char * )( Info.FileBuffer + Info.FileAddr + NameBytes ), Info.IniFileCharCodeFormat, &CharBytes ) ;
		if( ( EqualEnd && CharCode == Info.Equal ) ||
			CharCode == Info.Space    ||
			CharCode == Info.Tab      ||
			CharCode == Info.CR       ||
			CharCode == Info.LF       ||
			CharCode == Info.BracketR )
		{
			*pCharBytes = CharBytes ;
			return CharCode ;
		}
		else
		{
			NameBytes++ ;
		}
	}

	return 0 ;
}


__inline void GetPrivateProfileStringDx_PutString( GetPrivateProfileStringDxInfo &Info, const TCHAR *PutString, DWORD PutBytes )
{
	int i, j ;
	DWORD CharCode ;
	int CharBytes = 0 ;
	int PutCharBytes ;
	char CharString[ 18 ] ;
	int PutCharCodeFormat = _TCHARCODEFORMAT ;

	for( i = 0 ; ( DWORD )i < PutBytes ; i += CharBytes )
	{
		CharCode = GetCharCode( ( char * )( ( BYTE * )PutString + i ), Info.IniFileCharCodeFormat, &CharBytes ) ;
		PutCharBytes = PutCharCode( ConvCharCode( CharCode, Info.IniFileCharCodeFormat, PutCharCodeFormat ), PutCharCodeFormat, CharString, sizeof( CharString ) ) ;

		for( j = 0 ; j < PutCharBytes ; j += Info.UnitBytes )
		{
			if( Info.ReturnedStringBufferBytes < Info.DestBytes + Info.UnitBytes )
			{
				return ;
			}

			switch( Info.UnitBytes )
			{
			case 1 : *( ( BYTE  * )( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes ) ) = ( ( BYTE  * )CharString )[ j ] ; break ;
			case 2 : *( ( WORD  * )( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes ) ) = ( ( WORD  * )CharString )[ j ] ; break ;
			case 4 : *( ( DWORD * )( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes ) ) = ( ( DWORD * )CharString )[ j ] ; break ;
			}
			Info.DestBytes += Info.UnitBytes ;
		}
	}
}

extern int NS_GetPrivateProfileStringDx( const TCHAR *AppName, const TCHAR *KeyName, const TCHAR *Default, TCHAR *ReturnedStringBuffer, size_t ReturnedStringBufferBytes, const TCHAR *IniFilePath, int IniFileCharCodeFormat )
{
	int Return = -1 ;
	void *IniFileImage = NULL ;
	size_t IniFileImageBytes = 0 ;
	DWORD_PTR fp = 0 ;
	TCHAR_TO_WCHAR_T_STRING_BEGIN( IniFilePath )
	TCHAR_TO_WCHAR_T_STRING_SETUP( IniFilePath, goto END )

	// t@CۂƓǂݍ
	{
		fp = DX_FOPEN( UseIniFilePathBuffer ) ;
		if( fp == 0 )
		{
			goto END ;
		}
		DX_FSEEK( fp, 0, SEEK_END ) ;
		IniFileImageBytes = ( size_t )DX_FTELL( fp ) ;
		DX_FSEEK( fp, 0, SEEK_SET ) ;
		IniFileImage = DXALLOC( IniFileImageBytes ) ;
		if( IniFileImage == NULL )
		{
			goto END ;
		}
		DX_FREAD( IniFileImage, IniFileImageBytes, 1, fp ) ;
		DX_FCLOSE( fp ) ;
		fp = 0 ;
	}

	Return = NS_GetPrivateProfileStringDxForMem( AppName, KeyName, Default, ReturnedStringBuffer, ReturnedStringBufferBytes, IniFileImage, IniFileImageBytes, IniFileCharCodeFormat ) ;

END :

	TCHAR_TO_WCHAR_T_STRING_END( IniFilePath )

	if( fp != 0 )
	{
		DX_FCLOSE( fp ) ;
		fp = 0 ;
	}

	if( IniFileImage != NULL )
	{
		DXFREE( IniFileImage ) ;
		IniFileImage = NULL ;
	}

	return Return ;
}

// GetPrivateProfileString ̂cwCu
extern int NS_GetPrivateProfileStringDxWithStrLen( const TCHAR *AppName, size_t AppNameLength, const TCHAR *KeyName, size_t KeyNameLength, const TCHAR *Default, size_t DefaultLength, TCHAR *ReturnedString, size_t ReturnedStringBufferBytes, const TCHAR *IniFilePath, size_t IniFilePathLength, int IniFileCharCodeFormat )
{
	int Result = -1 ;

	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( AppName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( KeyName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( Default     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( IniFilePath )

	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( AppName,     AppNameLength,     goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( KeyName,     KeyNameLength,     goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( Default,     DefaultLength,     goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( IniFilePath, IniFilePathLength, goto ERR )

	Result = NS_GetPrivateProfileStringDx( AppNameBuffer, KeyNameBuffer, Default, ReturnedString, ReturnedStringBufferBytes, IniFilePathBuffer, IniFileCharCodeFormat ) ;

ERR :
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( AppName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( KeyName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( Default     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( IniFilePath )

	return Result ;
}

// GetPrivateProfileInt ̂cwCu
extern int NS_GetPrivateProfileIntDx( const TCHAR *AppName, const TCHAR *KeyName, int Default, const TCHAR *IniFilePath, int IniFileCharCodeFormat )
{
	TCHAR TempString[ 2048 ] ;
	int Size ;

	if( AppName == NULL || KeyName == NULL )
	{
		return Default ;
	}

	Size = NS_GetPrivateProfileStringDx( AppName, KeyName, NULL, TempString, sizeof( TempString ), IniFilePath, IniFileCharCodeFormat ) ;
	if( Size <= 0 )
	{
		return Default ;
	}

	return CL_atoi( _TCHARCODEFORMAT, ( char * )TempString ) ;
}

// GetPrivateProfileInt ̂cwCu
extern int NS_GetPrivateProfileIntDxWithStrLen( const TCHAR *AppName, size_t AppNameLength, const TCHAR *KeyName, size_t KeyNameLength, int Default, const TCHAR *IniFilePath, size_t IniFilePathLength, int IniFileCharCodeFormat )
{
	int Result = -1 ;

	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( AppName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( KeyName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( IniFilePath )

	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( AppName,     AppNameLength,     goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( KeyName,     KeyNameLength,     goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( IniFilePath, IniFilePathLength, goto ERR )

	Result = NS_GetPrivateProfileIntDx( AppNameBuffer, KeyNameBuffer, Default, IniFilePathBuffer, IniFileCharCodeFormat ) ;

ERR :
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( AppName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( KeyName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( IniFilePath )

	return Result ;
}

// GetPrivateProfileStringDx ̃ǂݍޔ
extern int NS_GetPrivateProfileStringDxForMem( const TCHAR *AppName, const TCHAR *KeyName, const TCHAR *Default, TCHAR *ReturnedStringBuffer, size_t ReturnedStringBufferBytes, const void *IniFileImage, size_t IniFileImageBytes, int IniFileCharCodeFormat )
{
	int Return = -1 ;
	DWORD CharCode ;
	int CharBytes ;
	DWORD NameBytes ;
	GetPrivateProfileStringDxInfo Info = { NULL, 0, 0 } ;
	DWORD AppNameBytes = 0 ;
	DWORD KeyNameBytes = 0 ;
	TCHAR_TO_CHAR_STRING_BEGIN( AppName )
	TCHAR_TO_CHAR_STRING_BEGIN( KeyName )
	TCHAR_TO_CHAR_STRING_BEGIN( Default )

	Info.FileSize = IniFileImageBytes ;
	Info.FileBuffer = ( BYTE * )IniFileImage ;

	// t@C̕R[h`FbN
	{
		if( IniFileCharCodeFormat < 0 )
		{
			IniFileCharCodeFormat = _TCHARCODEFORMAT ;
		}

		if( Info.FileSize >= 3 )
		{
			if( Info.FileBuffer[ 0 ] == 0xef && Info.FileBuffer[ 1 ] == 0xbb && Info.FileBuffer[ 2 ] == 0xbf )
			{
				IniFileCharCodeFormat = DX_CHARCODEFORMAT_UTF8 ;
				Info.FileAddr = 3 ;
			}
		}
		else
		if( Info.FileSize >= 2 )
		{
			if( Info.FileBuffer[ 0 ] == 0xff && Info.FileBuffer[ 1 ] == 0xfe )
			{
				IniFileCharCodeFormat = DX_CHARCODEFORMAT_UTF16LE ;
				Info.FileAddr = 2 ;
			}
			else
			if( Info.FileBuffer[ 0 ] == 0xfe && Info.FileBuffer[ 1 ] == 0xff )
			{
				IniFileCharCodeFormat = DX_CHARCODEFORMAT_UTF16BE ;
				Info.FileAddr = 2 ;
			}
		}
		Info.IniFileCharCodeFormat = IniFileCharCodeFormat ;
	}

	// ꕶӂ̃oCg
	Info.UnitBytes = GetCharCodeFormatUnitSize( _TCHARCODEFORMAT ) ;

	// o͐
	Info.ReturnedStringBuffer = ReturnedStringBuffer ;
	Info.ReturnedStringBufferBytes = ReturnedStringBufferBytes ;
	Info.DestBytes = 0 ;

	// t@CtH[}bgɍ̏
	TCHAR_TO_CHAR_STRING_SETUP( AppName, goto END, IniFileCharCodeFormat )
	TCHAR_TO_CHAR_STRING_SETUP( KeyName, goto END, IniFileCharCodeFormat )
	TCHAR_TO_CHAR_STRING_SETUP( Default, goto END, IniFileCharCodeFormat )
	Info.Semicolon = ConvCharCode( GetCharCode( ";",  DX_CHARCODEFORMAT_ASCII, NULL ), DX_CHARCODEFORMAT_ASCII, IniFileCharCodeFormat ) ;
	Info.BracketL  = ConvCharCode( GetCharCode( "[",  DX_CHARCODEFORMAT_ASCII, NULL ), DX_CHARCODEFORMAT_ASCII, IniFileCharCodeFormat ) ;
	Info.BracketR  = ConvCharCode( GetCharCode( "]",  DX_CHARCODEFORMAT_ASCII, NULL ), DX_CHARCODEFORMAT_ASCII, IniFileCharCodeFormat ) ;
	Info.Equal     = ConvCharCode( GetCharCode( "=",  DX_CHARCODEFORMAT_ASCII, NULL ), DX_CHARCODEFORMAT_ASCII, IniFileCharCodeFormat ) ;
	Info.Space     = ConvCharCode( GetCharCode( " ",  DX_CHARCODEFORMAT_ASCII, NULL ), DX_CHARCODEFORMAT_ASCII, IniFileCharCodeFormat ) ;
	Info.Tab       = ConvCharCode( GetCharCode( "\t", DX_CHARCODEFORMAT_ASCII, NULL ), DX_CHARCODEFORMAT_ASCII, IniFileCharCodeFormat ) ;
	Info.CR        = ConvCharCode( GetCharCode( "\r", DX_CHARCODEFORMAT_ASCII, NULL ), DX_CHARCODEFORMAT_ASCII, IniFileCharCodeFormat ) ;
	Info.LF        = ConvCharCode( GetCharCode( "\n", DX_CHARCODEFORMAT_ASCII, NULL ), DX_CHARCODEFORMAT_ASCII, IniFileCharCodeFormat ) ;

	// ZNVƃL[̃oCgZo
	if( AppName != NULL )
	{
		AppNameBytes = ( DWORD )CL_strlen( IniFileCharCodeFormat, ( char * )UseAppNameBuffer ) * GetCharCodeFormatUnitSize( IniFileCharCodeFormat ) ;
	}
	if( KeyName != NULL )
	{
		KeyNameBytes = ( DWORD )CL_strlen( IniFileCharCodeFormat, ( char * )UseKeyNameBuffer ) * GetCharCodeFormatUnitSize( IniFileCharCodeFormat ) ;
	}

	// ZNṼXgAbv̏ꍇ
	if( AppName == NULL )
	{
		if( Info.ReturnedStringBufferBytes < Info.UnitBytes * 2 )
		{
			Return = 0 ;
			goto END ;
		}

		while( Info.FileAddr < Info.FileSize )
		{
			CharCode = GetPrivateProfileStringDx_NextChar( Info, &CharBytes, TRUE, FALSE ) ;
			if( Info.FileAddr >= Info.FileSize )
			{
				break ;
			}

			// 劇ʂZNV
			if( CharCode == Info.BracketL )
			{
				Info.FileAddr += ( DWORD )CharBytes ;

				CharCode = GetPrivateProfileStringDx_NextChar( Info, &CharBytes, FALSE, TRUE ) ;
				if( Info.FileAddr >= Info.FileSize )
				{
					break ;
				}

				if( CharBytes > 0 )
				{
					GetPrivateProfileStringDx_GetName( Info, NameBytes, &CharBytes, FALSE ) ;
					if( NameBytes > 0 )
					{
						GetPrivateProfileStringDx_PutString( Info, ( TCHAR * )( Info.FileBuffer + Info.FileAddr ), NameBytes ) ;
						Info.FileAddr += NameBytes ;
						if( Info.DestBytes + Info.UnitBytes * 2 >= Info.ReturnedStringBufferBytes )
						{
							_MEMSET( Info.ReturnedStringBuffer + Info.ReturnedStringBufferBytes - Info.UnitBytes * 2, 0, Info.UnitBytes * 2 ) ;
							Return = ( int )( Info.ReturnedStringBufferBytes - Info.UnitBytes * 2 ) ;
							goto END ;
						}
						_MEMSET( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes, 0, Info.UnitBytes ) ;
						Info.DestBytes += Info.UnitBytes ;
						if( Info.DestBytes + Info.UnitBytes * 3 > Info.ReturnedStringBufferBytes )
						{
							_MEMSET( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes, 0, Info.UnitBytes ) ;
							Return = ( int )Info.ReturnedStringBufferBytes ;
							goto END ;
						}
					}
				}
			}

			// ̍sֈړ
			GetPrivateProfileStringDx_NextLine( Info ) ;
		}
		_MEMSET( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes, 0, Info.UnitBytes ) ;
		Return = ( int )( Info.DestBytes / Info.UnitBytes ) ;
	}
	else
	{
		// ZNV̌
		while( Info.FileAddr < Info.FileSize )
		{
			CharCode = GetPrivateProfileStringDx_NextChar( Info, &CharBytes, TRUE, FALSE ) ;
			if( Info.FileAddr >= Info.FileSize )
			{
				goto DEFAULT_END ;
			}

			if( CharCode == Info.BracketL )
			{
				Info.FileAddr += ( DWORD )CharBytes ;

				CharCode = GetPrivateProfileStringDx_NextChar( Info, &CharBytes, FALSE, TRUE ) ;
				if( Info.FileAddr >= Info.FileSize )
				{
					goto DEFAULT_END ;
				}

				if( CharBytes > 0 )
				{
					CharCode = GetPrivateProfileStringDx_GetName( Info, NameBytes, &CharBytes, FALSE ) ;
					if( AppNameBytes == NameBytes && _MEMCMP( Info.FileBuffer + Info.FileAddr, UseAppNameBuffer, NameBytes ) == 0 )
					{
						break ;
					}
					Info.FileAddr += NameBytes ;
				}
			}

			// ̍sֈړ
			GetPrivateProfileStringDx_NextLine( Info ) ;
		}
		if( Info.FileAddr >= Info.FileSize )
		{
			goto DEFAULT_END ;
		}
		GetPrivateProfileStringDx_NextLine( Info ) ;

		// L[̃XgAbv̏ꍇ
		if( KeyName == NULL )
		{
			if( Info.ReturnedStringBufferBytes < Info.UnitBytes * 2 )
			{
				Return = 0 ;
				goto END ;
			}

			while( Info.FileAddr < Info.FileSize )
			{
				CharCode = GetPrivateProfileStringDx_NextChar( Info, &CharBytes, TRUE, FALSE ) ;
				if( Info.FileAddr >= Info.FileSize || CharCode == Info.BracketL )
				{
					break ;
				}

				GetPrivateProfileStringDx_GetName( Info, NameBytes, &CharBytes, TRUE ) ;
				if( NameBytes > 0 )
				{
					BYTE *Addr = Info.FileBuffer + Info.FileAddr ;
					Info.FileAddr += NameBytes ;

					// ̕ = ǂmF
					CharCode = GetPrivateProfileStringDx_NextChar( Info, &CharBytes, TRUE, TRUE ) ;
					if( Info.FileAddr < Info.FileSize && CharCode == Info.Equal )
					{
						Info.FileAddr += CharBytes ;

						GetPrivateProfileStringDx_PutString( Info, ( TCHAR * )Addr, NameBytes ) ;
						if( Info.DestBytes + Info.UnitBytes * 2 > Info.ReturnedStringBufferBytes )
						{
							_MEMSET( Info.ReturnedStringBuffer + Info.ReturnedStringBufferBytes - Info.UnitBytes * 2, 0, Info.UnitBytes * 2 ) ;
							Return = ( int )( Info.ReturnedStringBufferBytes / Info.UnitBytes - 2 ) ;
							goto END ;
						}
						_MEMSET( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes, 0, Info.UnitBytes ) ;
						Info.DestBytes += Info.UnitBytes ;
						if( Info.DestBytes + Info.UnitBytes * 3 > Info.ReturnedStringBufferBytes )
						{
							_MEMSET( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes, 0, Info.UnitBytes ) ;
							Return = ( int )( Info.ReturnedStringBufferBytes / Info.UnitBytes ) - 1 ;
							goto END ;
						}
					}
				}

				// ̍sֈړ
				GetPrivateProfileStringDx_NextLine( Info ) ;
			}
			_MEMSET( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes, 0, Info.UnitBytes ) ;
			Return = ( int )( Info.DestBytes / Info.UnitBytes ) ;
		}
		else
		// L[̎擾̏ꍇ
		{
			if( Info.ReturnedStringBufferBytes <= Info.UnitBytes )
			{
				if( Info.ReturnedStringBufferBytes == Info.UnitBytes )
				{
					_MEMSET( Info.ReturnedStringBuffer, 0, Info.ReturnedStringBufferBytes ) ;
				}

				Return = 0 ;
				goto END ;
			}

			// L[̌
			while( Info.FileAddr < Info.FileSize )
			{
				CharCode = GetPrivateProfileStringDx_NextChar( Info, &CharBytes, TRUE, FALSE ) ;
				if( Info.FileAddr >= Info.FileSize || CharCode == Info.BracketL )
				{
					goto DEFAULT_END ;
				}

				CharCode = GetPrivateProfileStringDx_GetName( Info, NameBytes, &CharBytes, TRUE ) ;
				if( KeyNameBytes == NameBytes && _MEMCMP( Info.FileBuffer + Info.FileAddr, UseKeyNameBuffer, NameBytes ) == 0 )
				{
					Info.FileAddr += NameBytes ;
					break ;
				}
				Info.FileAddr += NameBytes ;

				// ̍sֈړ
				GetPrivateProfileStringDx_NextLine( Info ) ;
			}
			if( Info.FileAddr >= Info.FileSize )
			{
				goto DEFAULT_END ;
			}

			// ̕ = ǂmF
			CharCode = GetPrivateProfileStringDx_NextChar( Info, &CharBytes, TRUE, TRUE ) ;
			if( Info.FileAddr >= Info.FileSize || CharCode != Info.Equal )
			{
				goto DEFAULT_END ;
			}
			Info.FileAddr += CharBytes ;

			// ̎擾
			CharCode = GetPrivateProfileStringDx_NextChar( Info, &CharBytes, FALSE, TRUE ) ;
			if( CharCode == 0 )
			{
				Return = 0 ;
				_MEMSET( Info.ReturnedStringBuffer, 0, Info.UnitBytes ) ;
			}
			else
			{
				NameBytes = 0 ;
				while( Info.FileAddr + NameBytes < Info.FileSize )
				{
					CharCode = GetCharCode( ( char * )( Info.FileBuffer + Info.FileAddr + NameBytes ), Info.IniFileCharCodeFormat, &CharBytes ) ;
					if( CharCode == Info.CR || CharCode == Info.LF )
					{
						break ;
					}
					NameBytes += CharBytes ;
				}
				if( NameBytes == 0 )
				{
					Return = 0 ;
					_MEMSET( Info.ReturnedStringBuffer, 0, Info.UnitBytes ) ;
				}
				else
				{
					GetPrivateProfileStringDx_PutString( Info, ( TCHAR * )( Info.FileBuffer + Info.FileAddr ), NameBytes ) ;
					if( Info.DestBytes > Info.ReturnedStringBufferBytes - Info.UnitBytes )
					{
						Info.DestBytes = ( DWORD )( Info.ReturnedStringBufferBytes - Info.UnitBytes ) ;
					}
					_MEMSET( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes, 0, Info.UnitBytes ) ;
					Return = ( int )( Info.DestBytes / Info.UnitBytes ) ;
				}
			}
		}
	}

END :

	TCHAR_TO_CHAR_STRING_END( AppName )
	TCHAR_TO_CHAR_STRING_END( KeyName )
	TCHAR_TO_CHAR_STRING_END( Default )

	return Return ;

DEFAULT_END :
	if( Default != NULL )
	{
		GetPrivateProfileStringDx_PutString( Info, ( TCHAR * )UseDefaultBuffer, ( DWORD )CL_strlen( IniFileCharCodeFormat, ( char * )UseDefaultBuffer ) * GetCharCodeFormatUnitSize( IniFileCharCodeFormat ) ) ;
		if( Info.DestBytes > Info.ReturnedStringBufferBytes - Info.UnitBytes )
		{
			Info.DestBytes = ( DWORD )( Info.ReturnedStringBufferBytes - Info.UnitBytes ) ;
		}
	}
	_MEMSET( ( BYTE * )Info.ReturnedStringBuffer + Info.DestBytes, 0, Info.UnitBytes ) ;
	Return = ( int )( Info.DestBytes / Info.UnitBytes ) ;
	goto END ;
}

// GetPrivateProfileStringDx ̃ǂݍޔ
extern int NS_GetPrivateProfileStringDxForMemWithStrLen( const TCHAR *AppName, size_t AppNameLength, const TCHAR *KeyName, size_t KeyNameLength, const TCHAR *Default, size_t DefaultLength, TCHAR *ReturnedString, size_t ReturnedStringBufferBytes, const void *IniFileImage, size_t IniFileImageBytes, int IniFileCharCodeFormat )
{
	int Result = -1 ;

	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( AppName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( KeyName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( Default     )

	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( AppName,     AppNameLength,     goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( KeyName,     KeyNameLength,     goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( Default,     DefaultLength,     goto ERR )

	Result = NS_GetPrivateProfileStringDxForMem( AppNameBuffer, KeyNameBuffer, Default, ReturnedString, ReturnedStringBufferBytes, IniFileImage, IniFileImageBytes, IniFileCharCodeFormat ) ;

ERR :
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( AppName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( KeyName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( Default     )

	return Result ;
}

// GetPrivateProfileIntDx ̃ǂݍޔ
extern int NS_GetPrivateProfileIntDxForMem( const TCHAR *AppName, const TCHAR *KeyName, int Default, const void *IniFileImage, size_t IniFileImageBytes, int IniFileCharCodeFormat )
{
	TCHAR TempString[ 2048 ] ;
	int Size ;

	if( AppName == NULL || KeyName == NULL )
	{
		return Default ;
	}

	Size = NS_GetPrivateProfileStringDxForMem( AppName, KeyName, NULL, TempString, sizeof( TempString ), IniFileImage, IniFileImageBytes, IniFileCharCodeFormat ) ;
	if( Size <= 0 )
	{
		return Default ;
	}

	return CL_atoi( _TCHARCODEFORMAT, ( char * )TempString ) ;
}

// GetPrivateProfileIntDx ̃ǂݍޔ
extern int NS_GetPrivateProfileIntDxForMemWithStrLen( const TCHAR *AppName, size_t AppNameLength, const TCHAR *KeyName, size_t KeyNameLength, int Default, const void *IniFileImage, size_t IniFileImageBytes, int IniFileCharCodeFormat )
{
	int Result = -1 ;

	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( AppName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( KeyName     )

	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( AppName,     AppNameLength,     goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( KeyName,     KeyNameLength,     goto ERR )

	Result = NS_GetPrivateProfileIntDxForMem( AppNameBuffer, KeyNameBuffer, Default, IniFileImage, IniFileImageBytes, IniFileCharCodeFormat ) ;

ERR :
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( AppName     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( KeyName     )

	return Result ;
}

















#if defined( __APPLE__ ) || defined( __ANDROID__ )



// [Av𑗐M[ҏWԂŋN
// MailAddr    : ( NULL Ŗ )A[AhXꍇ̓J}w,xŋ؂Ă
// MainCCAddr  : CC ̈( NULL Ŗ )A[AhXꍇ̓J}w,xŋ؂Ă
// MainBCCAddr : BCC ̈( NULL Ŗ )A[AhXꍇ̓J}w,xŋ؂Ă
// Subject     : ^Cg( NULL Ŗ )A[AhXꍇ̓J}w,xŋ؂Ă
// Text        : {( NULL Ŗ )A[AhXꍇ̓J}w,xŋ؂Ă
extern int MailApp_Send_WCHAR_T( const wchar_t *MailAddr, const wchar_t *MailCCAddr, const wchar_t *MailBCCAddr, const wchar_t *Subject, const wchar_t *Text )
{
	// ˑ֐Ă
	return MailApp_Send_WCHAR_T_PF( MailAddr, MailCCAddr, MailBCCAddr, Subject, Text ) ;
}

extern int MailApp_Send( const TCHAR *MailAddr, const TCHAR *MailCCAddr, const TCHAR *MailBCCAddr, const TCHAR *Subject, const TCHAR *Text )
{
#ifdef UNICODE
	return MailApp_Send_WCHAR_T( MailAddr, MailCCAddr, MailBCCAddr, Subject, Text ) ;
#else
	int Result = -1 ;
	CHAR_TO_WCHAR_T_STRING_BEGIN( MailAddr    )
	CHAR_TO_WCHAR_T_STRING_BEGIN( MailCCAddr  )
	CHAR_TO_WCHAR_T_STRING_BEGIN( MailBCCAddr )
	CHAR_TO_WCHAR_T_STRING_BEGIN( Subject     )
	CHAR_TO_WCHAR_T_STRING_BEGIN( Text        )
	CHAR_TO_WCHAR_T_STRING_SETUP( MailAddr,    goto END, _TCHARCODEFORMAT )
	CHAR_TO_WCHAR_T_STRING_SETUP( MailCCAddr,  goto END, _TCHARCODEFORMAT )
	CHAR_TO_WCHAR_T_STRING_SETUP( MailBCCAddr, goto END, _TCHARCODEFORMAT )
	CHAR_TO_WCHAR_T_STRING_SETUP( Subject,     goto END, _TCHARCODEFORMAT )
	CHAR_TO_WCHAR_T_STRING_SETUP( Text,        goto END, _TCHARCODEFORMAT )

	Result = MailApp_Send_WCHAR_T( UseMailAddrBuffer, UseMailCCAddrBuffer, UseMailBCCAddrBuffer, UseSubjectBuffer, UseTextBuffer ) ;

END :
	TCHAR_TO_WCHAR_T_STRING_END( MailAddr    )
	TCHAR_TO_WCHAR_T_STRING_END( MailCCAddr  )
	TCHAR_TO_WCHAR_T_STRING_END( MailBCCAddr )
	TCHAR_TO_WCHAR_T_STRING_END( Subject     )
	TCHAR_TO_WCHAR_T_STRING_END( Text        )

	return Result ;
#endif
}

extern int MailApp_SendWithStrLen( const TCHAR *MailAddr, size_t MailAddrLength, const TCHAR *MailCCAddr, size_t MailCCAddrLength, const TCHAR *MailBCCAddr, size_t MailBCCAddrLength, const TCHAR *Subject, size_t SubjectLength, const TCHAR *Text, size_t TextLength )
{
	int Result = -1 ;
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( MailAddr    )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( MailCCAddr  )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( MailBCCAddr )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( Subject     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_BEGIN( Text        )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( MailAddr,    MailAddrLength,    goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( MailCCAddr,  MailCCAddrLength,  goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( MailBCCAddr, MailBCCAddrLength, goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( Subject,     SubjectLength,     goto ERR )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_SETUP( Text,        TextLength,        goto ERR )

	Result = MailApp_Send( UseMailAddrBuffer, UseMailCCAddrBuffer, UseMailBCCAddrBuffer, UseSubjectBuffer, UseTextBuffer ) ;

ERR :
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( MailAddr    )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( MailCCAddr  )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( MailBCCAddr )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( Subject     )
	TCHAR_STRING_WITH_STRLEN_TO_TCHAR_STRING_END( Text        )

	return Result ;
}

#endif // defined( __APPLE__ ) || defined( __ANDROID__ )

















// ǂݍݏn̊֐Ŕ񓯊ǂݍ݂sǂݒ肷( 񓯊ǂݍ݂ɑΉĂ֐̂ݗL )( TRUE:񓯊ǂݍ݂s  FALSE:񓯊ǂݍ݂sȂ( ftHg ) )
extern int NS_SetUseASyncLoadFlag( int Flag )
{
	DxSysData.ASyncLoadFlag = Flag ;

	// I
	return 0 ;
}

// ǂݍݏn̊֐Ŕ񓯊ǂݍ݂sǂ擾( 񓯊ǂݍ݂ɑΉĂ֐̂ݗL )( TRUE:񓯊ǂݍ݂s  FALSE:񓯊ǂݍ݂sȂ( ftHg ) )
extern int NS_GetUseASyncLoadFlag( void )
{
	return GetASyncLoadFlag() ;
}

// 񓯊ǂݍ݂sǂ擾( TRUE:񓯊ǂݍ݂s   FALSE:񓯊ǂݍ݂sȂ )
extern int GetASyncLoadFlag( void )
{
	return DxSysData.ASyncLoadFlag ? TRUE : FALSE ;
}

// cwCũEChE֘A̋@\gpȂtO
extern int NS_SetNotWinFlag( int Flag )
{
	if( Flag == TRUE ) DxSysData.NotDrawFlag = TRUE;
	DxSysData.NotWinFlag = Flag ;

	return 0 ;
}

// `@\gǂ̃tOZbg
extern int NS_SetNotDrawFlag( int Flag )
{
	DxSysData.NotDrawFlag = Flag ;

	return 0 ;
}

// `@\gǂ̃tO擾
extern int NS_GetNotDrawFlag( void )
{
	return DxSysData.NotDrawFlag ;
}

// TEh@\gǂ̃tOZbg
extern int NS_SetNotSoundFlag( int Flag )
{
	DxSysData.NotSoundFlag = Flag ;

	return 0;
}

// ͏Ԏ擾@\gǂ̃tOZbg
extern int NS_SetNotInputFlag( int Flag )
{
	DxSysData.NotInputFlag = Flag ;

	return 0;
}














// EGCgn֐

// w̎ԂƂ߂
extern int NS_WaitTimer( int WaitTime )
{
	ULONGLONG StartTime, EndTime ;

	StartTime = NS_GetNowSysPerformanceCount() ;

	// 4msecO܂ŐQ
	if( WaitTime > 4 )
	{
		// w莞Ԃ̊ԃbZ[W[v
		EndTime = StartTime + NS_ConvMilliSecondsToSysPerformanceCount( WaitTime - 4 ) ;
		while( EndTime > NS_GetNowSysPerformanceCount() )
		{
			// EBhEꂽꍇ͑ɏI
			if( NS_ProcessMessage() != 0 )
			{
				return 0 ;
			}
			Thread_Sleep( 1 ) ;
		}

	}

	// 4msecȉ͐̕mɑ҂
	EndTime = StartTime + NS_ConvMilliSecondsToSysPerformanceCount( WaitTime ) ;
	while( EndTime > NS_GetNowSysPerformanceCount() ){}

	// I
	return 0 ;
}

#ifndef DX_NON_INPUT

// L[̓͑҂
extern int NS_WaitKey( void )
{
	int BackCode = 0 ;

	while( ProcessMessage() == 0 && CheckHitKeyAll() != 0 )
	{
		Thread_Sleep( 1 ) ;
	}

	while( ProcessMessage() == 0 && ( BackCode = CheckHitKeyAll() ) == 0 )
	{
		Thread_Sleep( 1 ) ;
	}

//	while( ProcessMessage() == 0 && CheckHitKeyAll() != 0 )
//	{
//		Thread_Sleep( 1 ) ;
//	}

	return BackCode ;
}

#endif // DX_NON_INPUT















#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE





