// -------------------------------------------------------------------------------
// 
// 		cwCu		cŵfthc`wb_t@C
// 
// 				Ver 3.22c
// 
// -------------------------------------------------------------------------------

#ifndef DX_GUID_H
#define DX_GUID_H

#include "../DxCompileConfig.h"

#if !defined(CINTERFACE) && defined(__c2__) &&  __clang_major__ == 3 && __clang_minor__ == 8
//To avoid compile error
//C:\Program Files (x86)\Windows Kits\8.1\Include\um\combaseapi.h(229,21): error : unknown type name 'IUnknown'
//          static_cast<IUnknown*>(*pp);    // make sure everyone derives from IUnknown
#define CINTERFACE
#endif
#include <windows.h>


#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

extern GUID IID_IUNKNOWN ;
extern GUID IID_ISTREAM ;
extern GUID _GUID_NULL ;
extern GUID IID_IDIRECT3DHALDEVICE ;
extern GUID IID_IDIRECT3DTNLHALDEVICE  ;
extern GUID IID_IDIRECT3D7 ;
extern GUID IID_IDIRECT3DTEXTURE9 ;
extern GUID IID_IDXGIDEVICE1 ;
extern GUID IID_IDXGIOUTPUT1 ;
extern GUID IID_IDXGIFACTORY ;
extern GUID IID_IDXGIFACTORY1 ;
extern GUID IID_IDXGIFACTORY2 ;
extern GUID IID_ID3D11TEXTURE2D ;

extern GUID CLSID_DIRECTDRAW7 ;
extern GUID IID_IDIRECTDRAWSURFACE3 ;
extern GUID IID_IDIRECTDRAWSURFACE4 ;
extern GUID IID_IDIRECTDRAWSURFACE7 ;
extern GUID IID_IDIRECTDRAW ;
extern GUID IID_IDIRECTDRAW2 ;
extern GUID IID_IDIRECTDRAW4 ;
extern GUID IID_IDIRECTDRAW7 ;

extern GUID CLSID_FILTERGRAPH ;
extern GUID CLSID_FILTERMAPPER ;
extern GUID CLSID_AMMULTIMEDIASTREAM ;
extern GUID CLSID_VIDEOMIXINGRENDERER9 ;
extern GUID CLSID_MEMORYALLOCATOR ;
extern GUID CLSID_FILEWRITER ;
extern GUID CLSID_NULLRENDERER ;
extern GUID CLSID_WAVDEST ;
extern GUID IID_IMEMALLOCATOR ;
extern GUID IID_IMEMALLOCATORCALLBACKTEMP ;
extern GUID IID_IMEDIASAMPLE ;
extern GUID IID_IMEDIASAMPLE2 ;
extern GUID IID_IPIN ;
extern GUID CLSID_SAMPLEGRABBER ;
extern GUID CLSID_SEEKINGPASSTHRU ;
extern GUID CLSID_GRABBERSAMPLE ;
extern GUID IID_IGRABBERSAMPLE ;
extern GUID IID_ISEEKINGPASSTHRU ;
extern GUID IID_ISAMPLEGRABBER ;
extern GUID IID_FILESINKFILTER ;
extern GUID IID_FILESINKFILTER2 ;
extern GUID IID_IASYNCREADER ;

#define D_MEDIATYPE_NULL				_GUID_NULL
#define D_MEDIASUBTYPE_NULL				_GUID_NULL

extern GUID IID_IENUMMEDIATYPES ;
extern GUID IID_IENUMPINS ;
extern GUID IID_IAMOVIESETUP ;
extern GUID IID_IBASICAUDIO ;
extern GUID IID_IMEDIASEEKING ;
extern GUID IID_IMEDIAEVENT ;
extern GUID IID_IMEDIAEVENTEX ;
extern GUID IID_IMEDIACONTROL ;
extern GUID IID_IMEDIAPOSITION ;
extern GUID IID_IMEDIAEVENTSINK ;
extern GUID IID_IQUALITYCONTROL ;
extern GUID IID_IQUALPROP ;
extern GUID IID_IMEDIAFILTER ;
extern GUID IID_IPERSIST ;
extern GUID IID_IGRAPHBUILDER ;
extern GUID IID_IDIRECTDRAWMEDIASTREAM ;
extern GUID IID_IAMMEDIASTREAM ;
extern GUID IID_IAMMULTIMEDIASTREAM ;
extern GUID IID_IFILTERGRAPH ;
extern GUID IID_IFILTERGRAPH2 ;
extern GUID IID_IFILTERMAPPER ;
extern GUID LIBID_QUARTZTYPELIB ;
extern GUID IID_IMEMINPUTPIN ;
extern GUID IID_ISAMPLEGRABBERCB ;
extern GUID MSPID_PRIMARYAUDIO ;
extern GUID MSPID_PRIMARYVIDEO ;

extern GUID IID_IBASEFILTER ;
extern GUID IID_IVMRSURFACEALLOCATOR9 ;
extern GUID IID_IVMRSURFACEALLOCATORNOTIFY9 ;
extern GUID IID_IVMRIMAGEPRESENTER9 ;
extern GUID IID_IVMRFILTERCONFIG9 ;
extern GUID IID_IREFERENCECLOCK ;

extern GUID FORMAT_VIDEOINFO ;
extern GUID FORMAT_WAVEFORMATEX ;
extern GUID MEDIATYPE_VIDEO ;
extern GUID MEDIATYPE_AUDIO ;
extern GUID MEDIATYPE_STREAM ;
extern GUID D_MEDIASUBTYPE_YVYU ;
extern GUID D_MEDIASUBTYPE_YUYV ;
extern GUID D_MEDIASUBTYPE_UYVY ;
extern GUID D_MEDIASUBTYPE_YV12 ;
extern GUID D_MEDIASUBTYPE_NV11 ;
extern GUID D_MEDIASUBTYPE_NV12 ;
extern GUID D_MEDIASUBTYPE_YUY2 ;
extern GUID D_MEDIASUBTYPE_RGB24 ;
extern GUID D_MEDIASUBTYPE_RGB32 ;
extern GUID D_MEDIASUBTYPE_PCM ;
extern GUID D_MEDIASUBTYPE_WAVE ;
extern GUID D_MEDIASUBTYPE_MPEG1SYSTEM ;
extern GUID D_MEDIASUBTYPE_MPEG1AUDIO ;
extern GUID D_MEDIASUBTYPE_MPEG1VIDEO ;
extern GUID D_MEDIASUBTYPE_MPEG1VIDEOCD ;
extern GUID D_MEDIASUBTYPE_AVI ;
extern GUID D_MEDIASUBTYPE_QTMOVIE ;

extern GUID D_TIME_FORMAT_NONE ;
extern GUID D_TIME_FORMAT_FRAME ;
extern GUID D_TIME_FORMAT_BYTE ;
extern GUID D_TIME_FORMAT_SAMPLE ;
extern GUID D_TIME_FORMAT_FIELD ;
extern GUID D_TIME_FORMAT_MEDIA_TIME ;

extern GUID CLSID_DIRECTINPUT ;
extern GUID CLSID_DIRECTINPUT_ ;
extern GUID CLSID_DIRECTINPUT8 ;
extern GUID GUID_SYSKEYBOARD ;
extern GUID GUID_SYSMOUSE ;
extern GUID GUID_SINE ;
extern GUID GUID_CONSTANTFORCE ;
//#ifdef UNICODE
extern GUID IID_IDIRECTINPUTDEVICE8 ; // W
extern GUID IID_IDIRECTINPUTDEVICE7 ; // W
extern GUID IID_IDIRECTINPUTDEVICE2 ;
extern GUID IID_IDIRECTINPUTDEVICE ;
extern GUID IID_IDIRECTINPUT8 ;
extern GUID IID_IDIRECTINPUT7 ;
extern GUID IID_IDIRECTINPUT2 ;
extern GUID IID_IDIRECTINPUT ;
//#else
//extern GUID IID_IDIRECTINPUTDEVICE8 ; // A
//extern GUID IID_IDIRECTINPUTDEVICE7 ; // A
//extern GUID IID_IDIRECTINPUTDEVICE2 ;
//extern GUID IID_IDIRECTINPUTDEVICE ;
//extern GUID IID_IDIRECTINPUT8 ;
//extern GUID IID_IDIRECTINPUT7 ;
//extern GUID IID_IDIRECTINPUT2 ;
//extern GUID IID_IDIRECTINPUT ;
//#endif

extern GUID IID_IMMDEVICECOLLECTION ;
extern GUID IID_IMMDEVICEENUMERATOR ;
extern GUID CLSID_MMDEVICEENUMERATOR ;
extern GUID IID_IAUDIORENDERCLIENT ;
extern GUID IID_IAUDIOCLOCK ;
extern GUID IID_IAUDIOCLIENT ;
extern GUID D_KSDATAFORMAT_SUBTYPE_PCM ;
extern GUID D_KSDATAFORMAT_SUBTYPE_IEEE_FLOAT ;

extern GUID GUID_PERFMASTERVOLUME ;
extern GUID GUID_STANDARDMIDIFILE ;
extern GUID GUID_DIRECTMUSICALLTYPES ;
extern GUID CLSID_DIRECTSOUND ;
extern GUID CLSID_DIRECTMUSIC ;
extern GUID CLSID_DIRECTMUSICPERFORMANCE ;
extern GUID CLSID_DIRECTMUSICLOADER ;
extern GUID CLSID_DIRECTMUSICSEGMENT ;
extern GUID IID_IDIRECTSOUND ;
extern GUID IID_IDIRECTSOUNDBUFFER8 ;
extern GUID IID_IDIRECTMUSIC ;
extern GUID IID_IDIRECTMUSICLOADER8 ;
extern GUID IID_IDIRECTMUSICPERFORMANCE8 ;
extern GUID IID_IDIRECTMUSIC8 ;
extern GUID IID_IDIRECTMUSICSEGMENT8 ;

extern GUID IID_ITFSOURCE ;
extern GUID IID_ITFSOURCESINGLE ;
extern GUID IID_ITFUIELEMENTSINK ;
extern GUID IID_ITFINPUTPROCESSORPROFILEACTIVATIONSINK ;
extern GUID IID_ITFCOMPARTMENTEVENTSINK ;
extern GUID IID_ITFCOMPARTMENT ;
extern GUID IID_ITFUIELEMENT ;
extern GUID IID_ITFREADINGINFORMATIONUIELEMENT ;
extern GUID IID_ITFCANDIDATELISTUIELEMENT ;
extern GUID IID_ITFUIELEMENTMGR ;
extern GUID IID_ITFDOCUMENTMGR ;
extern GUID IID_ITFCOMPARTMENTMGR;
extern GUID CLSID_TF_THREADMGR ;
extern GUID IID_ITFTHREADMGR ;
extern GUID IID_ITFTHREADMGREX ;

extern GUID CLSID_XAUDIO2_0 ;
extern GUID CLSID_XAUDIO2_0_DEBUG ;
extern GUID CLSID_XAUDIO2_1 ;
extern GUID CLSID_XAUDIO2_1_DEBUG ;
extern GUID CLSID_XAUDIO2_2 ;
extern GUID CLSID_XAUDIO2_2_DEBUG ;
extern GUID CLSID_XAUDIO2_3 ;
extern GUID CLSID_XAUDIO2_3_DEBUG ;
extern GUID CLSID_XAUDIO2_4 ;
extern GUID CLSID_XAUDIO2_4_DEBUG ;
extern GUID CLSID_XAUDIO2_5 ;
extern GUID CLSID_XAUDIO2_5_DEBUG ;
extern GUID CLSID_XAUDIO2_6 ;
extern GUID CLSID_XAUDIO2_6_DEBUG ;
extern GUID CLSID_XAUDIO2_7 ;
extern GUID CLSID_XAUDIO2_7_DEBUG ;
extern GUID IID_IXAUDIO2 ;

extern GUID CLSID_AUDIOVOLUMEMeter2_0 ;
extern GUID CLSID_AUDIOVOLUMEMeter2_0_DEBUG ;
extern GUID CLSID_AUDIOREVERB2_0 ;
extern GUID CLSID_AUDIOREVERB2_0_DEBUG ;
extern GUID CLSID_AUDIOVOLUMEMeter2_1 ;
extern GUID CLSID_AUDIOVOLUMEMeter2_1_DEBUG ;
extern GUID CLSID_AUDIOREVERB2_1 ;
extern GUID CLSID_AUDIOREVERB2_1_DEBUG ;
extern GUID CLSID_AUDIOVOLUMEMeter2_2 ;
extern GUID CLSID_AUDIOVOLUMEMeter2_2_DEBUG ;
extern GUID CLSID_AUDIOREVERB2_2 ;
extern GUID CLSID_AUDIOREVERB2_2_DEBUG ;
extern GUID CLSID_AUDIOVOLUMEMeter2_3 ;
extern GUID CLSID_AUDIOVOLUMEMeter2_3_DEBUG ;
extern GUID CLSID_AUDIOREVERB2_3 ;
extern GUID CLSID_AUDIOREVERB2_3_DEBUG ;
extern GUID CLSID_AUDIOVOLUMEMeter2_4 ;
extern GUID CLSID_AUDIOVOLUMEMeter2_4_DEBUG ;
extern GUID CLSID_AUDIOREVERB2_4 ;
extern GUID CLSID_AUDIOREVERB2_4_DEBUG ;
extern GUID CLSID_AUDIOVOLUMEMeter2_5 ;
extern GUID CLSID_AUDIOVOLUMEMeter2_5_DEBUG ;
extern GUID CLSID_AUDIOREVERB2_5 ;
extern GUID CLSID_AUDIOREVERB2_5_DEBUG ;
extern GUID CLSID_AUDIOVOLUMEMeter2_6 ;
extern GUID CLSID_AUDIOVOLUMEMeter2_6_DEBUG ;
extern GUID CLSID_AUDIOREVERB2_6 ;
extern GUID CLSID_AUDIOREVERB2_6_DEBUG ;
extern GUID CLSID_AUDIOVOLUMEMeter2_7 ;
extern GUID CLSID_AUDIOVOLUMEMeter2_7_DEBUG ;
extern GUID CLSID_AUDIOREVERB2_7 ;
extern GUID CLSID_AUDIOREVERB2_7_DEBUG ;

extern GUID IID_IMF2DBUFFER ;
extern GUID IID_IMFBYTESTREAM ;
extern GUID IID_IMFATTRIBUTES ;

extern GUID D_MFMEDIATYPE_DEFAULT ;
extern GUID D_MFMEDIATYPE_AUDIO ;
extern GUID D_MFMEDIATYPE_VIDEO ;
extern GUID D_MFMEDIATYPE_PROTECTED ;
extern GUID D_MFMEDIATYPE_SAMI ;
extern GUID D_MFMEDIATYPE_SCRIPT ;
extern GUID D_MFMEDIATYPE_IMAGE ;
extern GUID D_MFMEDIATYPE_HTML ;
extern GUID D_MFMEDIATYPE_BINARY ;
extern GUID D_MFMEDIATYPE_FILETRANSFER ;

extern GUID D_MF_PD_DURATION ;

extern GUID D_MF_MT_MAJOR_TYPE ;
extern GUID D_MF_MT_SUBTYPE ;
extern GUID D_MF_MT_ALL_SAMPLES_INDEPENDENT ;
extern GUID D_MF_MT_FIXED_SIZE_SAMPLES ;
extern GUID D_MF_MT_COMPRESSED ;
extern GUID D_MF_MT_SAMPLE_SIZE ;
extern GUID D_MF_MT_WRAPPED_TYPE ;
extern GUID D_MF_MT_AUDIO_NUM_CHANNELS ;
extern GUID D_MF_MT_AUDIO_SAMPLES_PER_SECOND ;
extern GUID D_MF_MT_AUDIO_FLOAT_SAMPLES_PER_SECOND ;
extern GUID D_MF_MT_AUDIO_AVG_BYTES_PER_SECOND ;
extern GUID D_MF_MT_AUDIO_BLOCK_ALIGNMENT ;
extern GUID D_MF_MT_AUDIO_BITS_PER_SAMPLE ;
extern GUID D_MF_MT_AUDIO_VALID_BITS_PER_SAMPLE ;
extern GUID D_MF_MT_AUDIO_SAMPLES_PER_BLOCK ;
extern GUID D_MF_MT_AUDIO_CHANNEL_MASK ;
extern GUID D_MF_MT_DEFAULT_STRIDE ;
extern GUID D_MF_MT_FRAME_SIZE ;
extern GUID D_MF_MT_FRAME_RATE ;
extern GUID D_MF_MT_PIXEL_ASPECT_RATIO ;
extern GUID D_MF_MT_INTERLACE_MODE ;

extern GUID D_MFAUDIOFORMAT_BASE ;
extern GUID D_MFAUDIOFORMAT_PCM ;
extern GUID D_MFAUDIOFORMAT_FLOAT ;
extern GUID D_MFAUDIOFORMAT_DTS ;
extern GUID D_MFAUDIOFORMAT_DOLBY_AC3_SPDIF ;
extern GUID D_MFAUDIOFORMAT_DRM ;
extern GUID D_MFAUDIOFORMAT_WMAUDIOV8 ;
extern GUID D_MFAUDIOFORMAT_WMAUDIOV9 ;
extern GUID D_MFAUDIOFORMAT_WMAUDIO_LOSSLESS ;
extern GUID D_MFAUDIOFORMAT_WMASPDIF ;
extern GUID D_MFAUDIOFORMAT_MSP1 ;
extern GUID D_MFAUDIOFORMAT_MP3 ;
extern GUID D_MFAUDIOFORMAT_MPEG ;
extern GUID D_MFAUDIOFORMAT_AAC ;
extern GUID D_MFAUDIOFORMAT_ADTS ;

extern GUID D_MFVIDEOFORMAT_BASE ;
extern GUID D_MFVIDEOFORMAT_RGB32 ;
extern GUID D_MFVIDEOFORMAT_ARGB32 ;
extern GUID D_MFVIDEOFORMAT_RGB24 ;
extern GUID D_MFVIDEOFORMAT_RGB555 ;
extern GUID D_MFVIDEOFORMAT_RGB565 ;
extern GUID D_MFVIDEOFORMAT_RGB8 ;
extern GUID D_MFVIDEOFORMAT_AI44 ;
extern GUID D_MFVIDEOFORMAT_AYUV ;
extern GUID D_MFVIDEOFORMAT_YUY2 ;
extern GUID D_MFVIDEOFORMAT_YVYU ;
extern GUID D_MFVIDEOFORMAT_YVU9 ;
extern GUID D_MFVIDEOFORMAT_UYVY ;
extern GUID D_MFVIDEOFORMAT_NV11 ;
extern GUID D_MFVIDEOFORMAT_NV12 ;
extern GUID D_MFVIDEOFORMAT_YV12 ;
extern GUID D_MFVIDEOFORMAT_I420 ;
extern GUID D_MFVIDEOFORMAT_IYUV ;
extern GUID D_MFVIDEOFORMAT_Y210 ;
extern GUID D_MFVIDEOFORMAT_Y216 ;
extern GUID D_MFVIDEOFORMAT_Y410 ;
extern GUID D_MFVIDEOFORMAT_Y416 ;
extern GUID D_MFVIDEOFORMAT_Y41P ;
extern GUID D_MFVIDEOFORMAT_Y41T ;
extern GUID D_MFVIDEOFORMAT_Y42T ;
extern GUID D_MFVIDEOFORMAT_P210 ;
extern GUID D_MFVIDEOFORMAT_P216 ;
extern GUID D_MFVIDEOFORMAT_P010 ;
extern GUID D_MFVIDEOFORMAT_P016 ;
extern GUID D_MFVIDEOFORMAT_v210 ;
extern GUID D_MFVIDEOFORMAT_v216 ;
extern GUID D_MFVIDEOFORMAT_v410 ;
extern GUID D_MFVIDEOFORMAT_MP43 ;
extern GUID D_MFVIDEOFORMAT_MP4S ;
extern GUID D_MFVIDEOFORMAT_M4S2 ;
extern GUID D_MFVIDEOFORMAT_MP4V ;
extern GUID D_MFVIDEOFORMAT_WMV1 ;
extern GUID D_MFVIDEOFORMAT_WMV2 ;
extern GUID D_MFVIDEOFORMAT_WMV3 ;
extern GUID D_MFVIDEOFORMAT_WVC1 ;
extern GUID D_MFVIDEOFORMAT_MSS1 ;
extern GUID D_MFVIDEOFORMAT_MSS2 ;
extern GUID D_MFVIDEOFORMAT_MPG1 ;
extern GUID D_MFVIDEOFORMAT_DVSL ;
extern GUID D_MFVIDEOFORMAT_DVSD ;
extern GUID D_MFVIDEOFORMAT_DVHD ;
extern GUID D_MFVIDEOFORMAT_DV25 ;
extern GUID D_MFVIDEOFORMAT_DV50 ;
extern GUID D_MFVIDEOFORMAT_DVH1 ;
extern GUID D_MFVIDEOFORMAT_DVC ;
extern GUID D_MFVIDEOFORMAT_H264 ;
extern GUID D_MFVIDEOFORMAT_MJPG ;

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif
