// -------------------------------------------------------------------------------
// 
// 		cwCu		WindowsOSpTEhvOwb_t@C
// 
// 				Ver 3.22c
// 
// -------------------------------------------------------------------------------

#ifndef DX_SOUNDWIN_H
#define DX_SOUNDWIN_H

#include "../DxCompileConfig.h"

#ifndef DX_NON_SOUND

// CN[h ------------------------------------------------------------------
#include "../DxLib.h"
#include "DxDirectX.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// Xg[֌W̒`( WindowsHDDX[v̂ŁAt@C璼ڍĐꍇ̓obt@𑽂߂Ɋm )
#define STS_BUFSEC_FILE						(256 * 13)			// Xg[TEhĐɊmۂTEhobt@̎( Pʂ STS_DIVNUM1b )( t@C̃Xg[Đp )
#define STS_ADVANCECOPYSEC_FILE				(256 * 12 + 192)	// Xg[TEhĐɉf[^sWJĂő厞( Pʂ STS_DIVNUM1b )( t@C̃Xg[Đp )
#define STS_MINADVANCECOPYSEC_FILE			(256 * 12)			// Xg[TEhĐɉf[^sWJĂŏ( Pʂ STS_DIVNUM1b )( t@C̃Xg[Đp )

#define D_X3DAUDIO_INPUTCHANNELS			(8)				// X3DAudio ̌vZŎgpő̓`l

#ifndef DX_NON_ASIO
#define ASIO_DRV_DESC						L"description"
#define ASIO_PATH							L"software\\asio"
#define ASIO_MAX_DRIVER_NUM					(32)
#define ASIO_MAX_BUFFER_NUM					(16)
#define ASIO_MAX_PATH_LEN					(512)
#define ASIO_MAX_DRVNAME_LEN				(256)
#define ASIO_MAX_DRVNAME2_LEN				(32)
#endif // DX_NON_ASIO

// \̒` --------------------------------------------------------------------

// XAudio2pR[obNp\
struct SOUNDBUFFER_CALLBACK : public D_IXAudio2VoiceCallback
{
	virtual void    __stdcall OnVoiceProcessingPassStart( DWORD BytesRequired ) ;
	virtual void    __stdcall OnVoiceProcessingPassEnd	() ;
	virtual void    __stdcall OnStreamEnd				() ;
	virtual void    __stdcall OnBufferStart				( void* pBufferContext ) ;
	virtual void    __stdcall OnBufferEnd				( void* pBufferContext ) ;
	virtual void    __stdcall OnLoopEnd					( void* pBufferContext ) ;
	virtual void    __stdcall OnVoiceError				( void* pBufferContext, HRESULT Error ) ;

	struct SOUNDBUFFER			*Buffer ;
} ;

// TEhobt@ˑ\
struct SOUNDBUFFER_PF
{
	union
	{
		D_IDirectSoundBuffer 		*DSBuffer ;				// DirectSoundBuffer
		D_IXAudio2SourceVoice		*XA2SourceVoice ;		// XAudio2SourceVoice
		D_IXAudio2_8SourceVoice		*XA2_8SourceVoice ;		// XAudio2_8SourceVoice
	} ;
	union
	{
		D_IXAudio2SubmixVoice		*XA2SubmixVoice ;		// XAudio2SubmixVoice
		D_IXAudio2_8SubmixVoice		*XA2_8SubmixVoice ;		// XAudio2_8SubmixVoice
	} ;
	D_IUnknown					*XA2ReverbEffect ;		// o[uGtFNg
	SOUNDBUFFER_CALLBACK		*XA2Callback ;			// XAudio2p̃R[obN

	union
	{
		D_XAUDIO2FX_REVERB_PARAMETERS    XAudio2ReverbParameter ;	// o[uvZpp[^
		D_XAUDIO2FX_REVERB_PARAMETERS2_8 XAudio2_8ReverbParameter ;	// o[uvZpp[^XAudio2.8p
	} ;

	int							XAudioChannels ;		// XAudio ł̃`l

	// RcTEhĐpf[^
	D_X3DAUDIO_EMITTER			X3DAudioEmitterData ;									// RcTEhp
	D_X3DAUDIO_CONE				X3DAudioEmitterConeData ;								// RcTEhpŎgpR[
	float						X3DAudioEmitterChannelAzimuths[ D_X3DAUDIO_INPUTCHANNELS ] ;	// RcTEhpŎgp`lʒue[u
} ;

// TEhVXepˑf[^\
struct SOUNDSYSTEMDATA_PF
{
	D_IDirectMusicLoader8		*DirectMusicLoaderObject ;		// DirectMusicLoader8 IuWFNg
	D_IDirectMusicPerformance8	*DirectMusicPerformanceObject ;	// DirectMusicPerformance8 IuWFNg

	HMODULE						XAudio2_8DLL ;					// XAudio2_8.dll
	HRESULT						( WINAPI *XAudio2CreateFunc )( D_IXAudio2_8 ** ppXAudio2, DWORD Flags, D_XAUDIO2_PROCESSOR XAudio2Processor );
	HRESULT						( WINAPI *CreateAudioVolumeMeterFunc )( D_IUnknown** ppApo ) ;
	HRESULT						( WINAPI *CreateAudioReverbFunc )( D_IUnknown** ppApo ) ;

	HMODULE						X3DAudioDLL ;					// X3DAudio.dll
	void						( __cdecl *X3DAudioInitializeFunc )( DWORD SpeakerChannelMask, float SpeedOfSound, D_X3DAUDIO_HANDLE Instance ) ;
	void						( __cdecl *X3DAudioCalculateFunc )( const D_X3DAUDIO_HANDLE Instance, const D_X3DAUDIO_LISTENER* pListener, const D_X3DAUDIO_EMITTER* pEmitter, DWORD Flags, D_X3DAUDIO_DSP_SETTINGS* pDSPSettings ) ;

	union
	{
		D_IXAudio2				*XAudio2Object ;				// XAudio2IuWFNg
		D_IXAudio2_8			*XAudio2_8Object ;				// XAudio2_8IuWFNg
		D_IDirectSound			*DirectSoundObject ;			// crIuWFNg
		DWORD_PTR				InitializeFlag ;				// O~LVOptO
	} ;

	D_XAUDIO2FX_REVERB_PARAMETERS    XAudio2ReverbParameters[ D_XAUDIO2FX_PRESET_NUM ] ;	// o[uvZpp[^
	D_XAUDIO2FX_REVERB_PARAMETERS2_8 XAudio2_8ReverbParameters[ D_XAUDIO2FX_PRESET_NUM ] ;	// o[uvZpp[^XAudio2.8p
	D_IXAudio2MasteringVoice	*XAudio2MasteringVoiceObject ;	// XAudio2MasteringVoiceIuWFNg
	D_IXAudio2_8MasteringVoice	*XAudio2_8MasteringVoiceObject ;// XAudio2_8MasteringVoiceIuWFNg
	D_XAUDIO2_EFFECT_CHAIN		XAudio2MasteringEffectChain ;	// }X^[{CXp̃GtFNg`FC

	DWORD						XAudio2OutputChannelMask ;		// o̓`l}XN

	D_X3DAUDIO_HANDLE			X3DAudioInstance ;				// RcTEhvZpCX^Xnh
	D_X3DAUDIO_CONE				X3DAudioListenerConeData ;		// RcTEh̃Xi[ɎgpR[
	D_X3DAUDIO_LISTENER			X3DAudioListenerData ;			// RcTEh̃Xi[

	D_WAVEFORMATEXTENSIBLE		SelfMixingFormatEx ;			// O~LVOtH[}bg WAVEFORMATEXTENSIBLE 

	D_IMMDeviceEnumerator		*IMMDeviceEnumerator ;			// }`fBAfoCX񋓃C^[tF[X
	D_IMMDevice					*IMMDevice ;					// foCXC^[tF[X
	D_IAudioClient				*AudioClient ;					// I[fBINCAgC^[tF[X
	D_IAudioClock				*AudioClock ;					// I[fBINbNC^[tF[X
	D_IAudioRenderClient		*AudioRenderClient ;			// _[NCAgC^[tF[X
	HANDLE						WASAPI_Event ;					// WASAPIpCxgnh
	HANDLE						WASAPI_ThreadHandle ;			// WASAPIpXbhnh
	BOOL						WASAPI_ThreadLoop ;				// WASAPIpXbh
	D_REFERENCE_TIME			WASAPI_DevicePeriod ;			// WASAPĨfoCXsIh
	D_REFERENCE_TIME			WASAPI_DefaultDevicePeriod ;	// WASAPĨftHgfoCXsIh
	D_REFERENCE_TIME			WASAPI_MinimumDevicePeriod ;	// WASAPI̍ŏfoCXsIh
	DWORD						WASAPI_BufferSamples ;			// WASAPĨobt@̃Tv
	int							WASAPI_IsExclusiveFlag ;		// WASAPIr[hŎgp邩ǂ̃tO( TRUE:r[h  FALSE:L[h )

	int							WASAPI_EnableUserParam ;		// WASAPĨ[U[ݒp[^L
	int							WASAPI_UserParam_DevicePeriod ;	// WASAPĨfoCXsIh
	int							WASAPI_UserParam_SamplePerSec ;	// WASAPĨTvO[g

#ifndef DX_NON_ASIO
	long						ASIO_DriverNum ;				// ASIOhCo[̐
	int							ASIO_DriverUseIndex ;			// gpASIOhCo
	char						ASIO_DriverPaths[ ASIO_MAX_DRIVER_NUM ][ ASIO_MAX_PATH_LEN ] ;		// ASIOhCo[̃pX
	wchar_t						ASIO_DriverNames[ ASIO_MAX_DRIVER_NUM ][ ASIO_MAX_DRVNAME_LEN ] ;	// ASIOhCo[̖O
	char						ASIO_DriverNames2[ ASIO_MAX_DRIVER_NUM ][ ASIO_MAX_DRVNAME2_LEN ] ;	// ASIOhCo[̖ÔQ
	long						ASIO_DriverVersion[ ASIO_MAX_DRIVER_NUM ] ;	// ASIOhCo[̃o[W
	GUID						ASIO_DriverGUID[ ASIO_MAX_DRIVER_NUM ] ;	// ASIOhCoGUID
	D_IASIO						*ASIO_Driver[ ASIO_MAX_DRIVER_NUM ] ;		// ASIOhCoIuWFNg
	long						ASIO_BufferMiniNum ;			// obt@̍ŏTCY
	long						ASIO_BufferMaxiNum ;			// obt@̍őTCY
	long						ASIO_Preferred ;				// Dobt@TCYiTCYptH[}Xƃn[hEFA̗vɍœKj
	long						ASIO_BufferSize ;				// gpۂ̃obt@TCY
	long						ASIO_Granularity ;				// obt@TCY̗x
	D_ASIOBufferInfo			ASIO_BufferInfo[ ASIO_MAX_BUFFER_NUM ] ;	// obt@
	int							ASIO_EnableUserParam ;			// ASIÕ[U[ݒp[^L
	int							ASIO_UserParam_BufferSize ;		// ASIÕfoCXsIh
	int							ASIO_UserParam_SamplePerSec ;	// ASIÕTvO[g
#endif // DX_NON_ASIO

	D_IDirectSoundBuffer		*PrimarySoundBuffer ;			// vC}TEhobt@

	D_IDirectSoundBuffer		*NoSoundBuffer ;				// obt@

	int							EnableXAudioFlag ;				// XAudiogp邩ǂ̃tO( TRUE:gp  FALSE:gpȂ ) 
	int							DisableWASAPIFlag ;				// WASAPIgpȂǂ̃tO( TRUE:gp  FALSE:gpȂ ) 
#ifndef DX_NON_ASIO
	int							EnableASIOFlag ;				// ASIOgp邩ǂ̃tO( TRUE:gp  FALSE:gpȂ ) 
#endif // DX_NON_ASIO
	int							UseSoftwareMixing ;				// \tgEGA~LVOsǂ̃tO( TRUE:\tgEGA  FALSE:n[hEGA )

	HANDLE						StreamSoundThreadHandle ;		// Xg[TEhĐ鏈sXbh̃nh
	DWORD						StreamSoundThreadID ;			// Xg[TEhĐ鏈sXbĥhc
	DWORD						StreamSoundThreadEndFlag ;		// Xg[TEhĐ鏈I邩ǂ̃tO
} ;

// lhchf[^ˑ
struct MIDIHANDLEDATA_PF
{
	D_IDirectMusicSegment8		*DirectMusicSegmentObject ;		// DirectMusicSegment8 IuWFNg
} ;

// lhchVXepˑf[^\
struct MIDISYSTEMDATA_PF
{
	UINT						MidiDeviceID ;					// lhcht̃foCXhc
} ;

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

extern	int		MidiCallBackProcess( void ) ;																			// lhchtIĂ΂R[obN֐


#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_SOUND

#endif // DX_SOUNDWIN_H
